package com.rockymadden.jbrainhoney;

import java.io.Serializable;

/**
 * Defines the interface of a value class. This interface primarily serves the purpose of defining that value classes
 * should override the methods outlined to meet generally accepted best practices.
 */
public abstract interface ValueClass extends Serializable {
	@Override
	public abstract String toString();

	@Override
	public abstract boolean equals(final Object object);

	@Override
	public abstract int hashCode();

	/** Defines the interface of a ValueClass builder. */
	public static interface Builder {
		public abstract ValueClass build();
	}
}
