package com.rockymadden.jbrainhoney.dlap.command;

/**
 * A command which refreshes the authentication cookie for the current session. The authentication cookie is refreshed
 * on every call. You can call this command to keep a session alive if the interval between calls is long
 * (over 10 minutes). See the
 * {@link <a href="http://gls.agilix.com/Docs/Command/GetCookie">the BrainHoney DLAP API guide</a>} for this command.
 */
public final class GetCookieCommand implements Command {
	private GetCookieCommand(final Builder builder) {

	}

	/** A builder of immutable GetCookieCommand instances. */
	public final static class Builder implements Command.Builder {
		public Builder() {
			super();
		}

		@Override
		@SuppressWarnings("synthetic-access")
		public GetCookieCommand build() {
			return new GetCookieCommand(this);
		}
	}
}