package com.rockymadden.jbrainhoney.dlap.command;

/** Defines the interface of an observable Command. */
public abstract interface ObservableCommand<O extends CommandObserver<? extends CommandEvent>> {
	public abstract ObservableCommand<O> addObserver(final O observer);

	public abstract ObservableCommand<O> removeObserver(final O observer);

	/** Defines the interface of an observable Command builder. */
	public abstract static interface Builder<O extends CommandObserver<? extends CommandEvent>> {
		public abstract ObservableCommand.Builder<O> addObserver(final O observer);

		public abstract ObservableCommand.Builder<O> removeObserver(final O observer);
	}
}