package com.rockymadden.jbrainhoney.dlap.enumeration;

import java.util.EnumSet;
import com.rockymadden.jbrainhoney.dlap.element.Actor;
import com.rockymadden.jbrainhoney.dlap.element.User;

/** Enumerates actor types. */
public enum ActorType implements ClassLiteralEnumeration<Actor> {
	USER(User.class);

	private final Class<? extends Actor> classLiteral;

	private ActorType(final Class<? extends Actor> classLiteral) {
		this.classLiteral = classLiteral;
	}

	@Override
	public Class<? extends Actor> getClassLiteral() {
		return classLiteral;
	}

	public static ActorType valueOfClassLiteral(final Class<? extends Actor> classLiteral)
		throws IllegalArgumentException {

		if(classLiteral == null) throw new IllegalArgumentException("Expected classLiteral to not be null.");

		ActorType enumeration = null;

		for(ActorType element : EnumSet.allOf(ActorType.class)) {
			if(element.getClassLiteral() != null && element.getClassLiteral().equals(classLiteral)) {
				enumeration = element;
				break;
			}
		}

		if(enumeration == null) throw new IllegalArgumentException("Expected classLiteral match.");


		return enumeration;
	}
}