package com.rockymadden.jbrainhoney.dlap.enumeration;

import java.util.EnumSet;

/** Enumerates copy actions. */
public enum CopyAction implements ValueEnumeration {
	COPY("Copy"),
	DERIVATIVE("Derivative"),
	DERIVITIVECOPY("DerivativeCopy");

	private final String value;

	private CopyAction(final String value) {
		this.value = value;
	}

	@Override
	public String getValue() {
		return value;
	}

	public static CopyAction valueOfValue(final String value) throws IllegalArgumentException {
		if(value == null) throw new IllegalArgumentException("Expected value to not be null.");

		CopyAction enumeration = null;

		for(CopyAction element : EnumSet.allOf(CopyAction.class)) {
			if(element.getValue() != null && element.getValue().equals(value)) {
				enumeration = element;
				break;
			}
		}

		if(enumeration == null) throw new IllegalArgumentException("Expected value match.");

		return enumeration;
	}
}