package com.rockymadden.jbrainhoney.dlap.enumeration;

import java.util.EnumSet;

/** Enumerates course types. */
public enum CourseType implements ValueEnumeration {
	CONTINUOUS("Continuous"),
	RANGE("Range");

	private final String value;

	private CourseType(final String value) {
		this.value = value;
	}

	@Override
	public String getValue() {
		return value;
	}

	public static CourseType valueOfValue(final String value) throws IllegalArgumentException {
		if(value == null) throw new IllegalArgumentException("Expected value to not be null.");

		CourseType enumeration = null;

		for(CourseType element : EnumSet.allOf(CourseType.class)) {
			if(element.getValue() != null && element.getValue().equals(value)) {
				enumeration = element;
				break;
			}
		}

		if(enumeration == null) throw new IllegalArgumentException("Expected value match.");

		return enumeration;
	}
}