package com.rockymadden.jbrainhoney.dlap.enumeration;

import java.util.EnumSet;

/** Enumerates rights. */
public enum DigitalCourseProtection implements BitwiseValueEnumeration {
	NONE(0l),
	ENCRYPT(1l),
	DISABLEWEBCLIENT(2l),
	DISABLERICHCLIENT(4l),
	DISABLECLIPBOARDCOPY(16l),
	DISABLESAVEAS(32l),
	DISABLEPRINT(64l);

	private final Long value;

	private DigitalCourseProtection(final Long value) {
		this.value = value;
	}

	@Override
	public Long getValue() {
		return value;
	}

	public static DigitalCourseProtection valueOfValue(final Long value) throws IllegalArgumentException {
		if(value == null) throw new IllegalArgumentException("Expected value to not be null.");

		DigitalCourseProtection enumeration = null;

		for(DigitalCourseProtection element : EnumSet.allOf(DigitalCourseProtection.class)) {
			if(element.getValue() != null && element.getValue().equals(value)) {
				enumeration = element;
				break;
			}
		}

		if(enumeration == null) throw new IllegalArgumentException("Expected value match.");

		return enumeration;
	}
}