package com.rockymadden.jbrainhoney.dlap.enumeration;

import java.util.EnumSet;

/** Enumerates enrollment statuses. */
public enum EnrollmentStatus implements ValueEnumeration {
	ACTIVE(1),
	WITHDRAWN(4),
	WITHDRAWNFAILED(5),
	TRANSFERRED(6),
	COMPLETED(7),
	COMPLETEDNOCREDIT(8),
	SUSPENDED(9),
	INACTIVE(10);

	private final Integer value;

	private EnrollmentStatus(final Integer value) {
		this.value = value;
	}

	@Override
	public Integer getValue() {
		return value;
	}

	public static EnrollmentStatus valueOfValue(final Integer value) throws IllegalArgumentException {
		if(value == null) throw new IllegalArgumentException("Expected value to not be null.");

		EnrollmentStatus enumeration = null;

		for(EnrollmentStatus element : EnumSet.allOf(EnrollmentStatus.class)) {
			if(element.getValue() != null && element.getValue().equals(value)) {
				enumeration = element;
				break;
			}
		}

		if(enumeration == null) throw new IllegalArgumentException("Expected value match.");

		return enumeration;
	}
}