package com.rockymadden.jbrainhoney.dlap.enumeration;

import java.util.EnumSet;

/** Enumerates entity flags. */
public enum EntityFlag implements BitwiseValueEnumeration {
	NONE(0l),
	DELETED(1l);

	private final Long value;

	private EntityFlag(final Long value) {
		this.value = value;
	}

	@Override
	public Long getValue() {
		return value;
	}

	public static EntityFlag valueOfValue(final Long value) throws IllegalArgumentException {
		if(value == null) throw new IllegalArgumentException("Expected value to not be null.");

		EntityFlag enumeration = null;

		for(EntityFlag element : EnumSet.allOf(EntityFlag.class)) {
			if(element.getValue() != null && element.getValue().equals(value)) {
				enumeration = element;
				break;
			}
		}

		if(enumeration == null) throw new IllegalArgumentException("Expected value match.");

		return enumeration;
	}
}