package com.rockymadden.jbrainhoney.dlap.enumeration;

import java.util.EnumSet;

/** Enumerates flag schemas. */
public enum FlagSchema implements ValueEnumeration {
	DISTINCT(1),
	INDISTINCT(2);

	private final Integer value;

	private FlagSchema(final Integer value) {
		this.value = value;
	}

	@Override
	public Integer getValue() {
		return value;
	}

	public static FlagSchema valueOfValue(final Integer value) throws IllegalArgumentException {
		if(value == null) throw new IllegalArgumentException("Expected value to not be null.");

		FlagSchema enumeration = null;

		for(FlagSchema element : EnumSet.allOf(FlagSchema.class)) {
			if(element.getValue() != null && element.getValue().equals(value)) {
				enumeration = element;
				break;
			}
		}

		if(enumeration == null) throw new IllegalArgumentException("Expected value match.");

		return enumeration;
	}
}