package com.rockymadden.jbrainhoney.dlap.enumeration;

import java.util.EnumSet;

/** Enumerates rights. */
public enum RightFlag implements BitwiseValueEnumeration {
	OWNER(-1l),
	NONE(0l),
	PARTICIPATE(1l),
	CREATEDOMAIN(16l),
	READDOMAIN(32l),
	UPDATEDOMAIN(64l),
	DELETEDOMAIN(128l),
	CREATEUSER(256l),
	READUSER(512l),
	UPDATEUSER(1024l),
	DELETEUSER(2048l),
	CREATECOURSE(65536l),
	READCOURSE(131072l),
	UPDATECOURSE(262144l),
	DELETECOURSE(524288l),
	CREATESECTION(1048576l),
	READSECTION(2097152l),
	UPDATESECTION(4194304l),
	DELETESECTION(8388608l),
	GRADEASSIGNMENT(16777216l),
	GRADEFORUM(33554432l),
	GRADEEXAM(67108864l),
	SETUPGRADEBOOK(134217728l),
	CONTROLDOMAIN(268435456l),
	CONTROLCOURSE(536870912l),
	CONTROLSECTION(1073741824l),
	READGRADEBOOK(2147483648l),
	REPORTDOMAIN(4294967296l),
	REPORTCOURSE(8589934592l),
	REPORTSECTION(17179869184l),
	POSTDOMAINANNOUNCEMENTS(34359738368l),
	PROXY(68719476736l),
	REPORTUSER(274877906944l),
	SUBMITFINALGRADE(549755813888l);

	private final Long value;

	private RightFlag(final Long value) {
		this.value = value;
	}

	@Override
	public Long getValue() {
		return value;
	}

	public static RightFlag valueOfValue(final Long value) throws IllegalArgumentException {
		if(value == null) throw new IllegalArgumentException("Expected value to not be null.");

		RightFlag enumeration = null;

		for(RightFlag element : EnumSet.allOf(RightFlag.class)) {
			if(element.getValue() != null && element.getValue().equals(value)) {
				enumeration = element;
				break;
			}
		}

		if(enumeration == null) throw new IllegalArgumentException("Expected value match.");

		return enumeration;
	}
}