package com.rockymadden.jbrainhoney.dlap.validate;

/** A validator class for an email attribute. */
public final class EmailAttributeValidator implements AttributeValidator<String> {
	private volatile static EmailAttributeValidator instance;

	private EmailAttributeValidator() {

	}

	@Override
	public boolean isValid(final String email) {
		if(email == null || email.length() == 0 || email.length() > 256
			|| !email.matches("[a-zA-Z0-9!#$%&'*+/=?^_`{|}~-]+(?:\\.[a-zA-Z0-9!#$%&'*+/=?^_`{|}~-]+)*@(?:[a-z0-9](?:[a-z0-9-]*[a-z0-9])?\\.)+[a-z0-9](?:[a-z0-9-]*[a-z0-9])?"))

			return false;
		else return true;
	}

	public static EmailAttributeValidator getInstance() {
		if(instance == null) synchronized(EmailAttributeValidator.class) {
			if(instance == null) instance = new EmailAttributeValidator();
		}

		return instance;
	}

	@Override
	public final java.lang.Object clone() throws CloneNotSupportedException {
		 throw new CloneNotSupportedException();
	}
}