package com.rockymadden.jbrainhoney.dlap.validate;

/** A validator class for a guid attribute. */
public final class GuidAttributeValidator implements AttributeValidator<String> {
	private volatile static GuidAttributeValidator instance;

	private GuidAttributeValidator() {

	}

	@Override
	public boolean isValid(final String guid) {
		if(guid == null || guid.length() == 0
			|| !guid.matches("^([0-9a-fA-F]{8}\\-[0-9a-fA-F]{4}\\-[0-9a-fA-F]{4}\\-[0-9a-fA-F]{4}\\-[0-9a-fA-F]{12})$"))

			return false;
		else return true;
	}

	public static GuidAttributeValidator getInstance() {
		if(instance == null) synchronized(GuidAttributeValidator.class) {
			if(instance == null) instance = new GuidAttributeValidator();
		}

		return instance;
	}

	@Override
	public final java.lang.Object clone() throws CloneNotSupportedException {
		 throw new CloneNotSupportedException();
	}
}