package com.rockymadden.jbrainhoney.dlap.validate;

/** A validator class for a reference attribute. */
public final class ReferenceAttributeValidator implements AttributeValidator<String> {
	private volatile static ReferenceAttributeValidator instance;

	private ReferenceAttributeValidator() {

	}

	@Override
	public boolean isValid(final String reference) {
		if(reference == null || reference.length() == 0 || reference.length() > 128
			|| !reference.matches("^([^/\\|\\{\\}]+?)$")) return false;
		else return true;
	}

	public static ReferenceAttributeValidator getInstance() {
		if(instance == null) synchronized(ReferenceAttributeValidator.class) {
			if(instance == null) instance = new ReferenceAttributeValidator();
		}

		return instance;
	}

	@Override
	public final java.lang.Object clone() throws CloneNotSupportedException {
		 throw new CloneNotSupportedException();
	}
}