package com.rockymadden.jbrainhoney.network;

import com.rockymadden.jbrainhoney.SimpleValueClass;

/** Defines the interface of a URI that is common to all RFCs. */
public abstract interface Uri extends SimpleValueClass {
	public abstract Schemeable getScheme();

	public abstract String getHostname();

	public abstract Integer getPort();

	/** Defines the interface of a Uri builder. */
	public static interface Builder extends SimpleValueClass.Builder {
		public abstract Uri.Builder setPort(final Integer port);

		@Override
		public abstract Uri build();
	}

	/** Defines the interface of an absolute URI scheme enumeration. */
	public interface Schemeable {

	}
}
