package com.rockymadden.jbrainhoney.network.http;

import java.util.List;
import org.apache.http.cookie.Cookie;
import com.rockymadden.jbrainhoney.network.Client;
import com.rockymadden.jbrainhoney.network.http.request.GetRequest;
import com.rockymadden.jbrainhoney.network.http.request.PostRequest;

/** Defines the interface of a HTTP based Client. */
public interface HttpClient extends Client {
	public abstract String get(final GetRequest getRequest) throws IllegalArgumentException, HttpException;

	public abstract String post(final PostRequest postRequest) throws IllegalArgumentException, HttpException;

	public abstract boolean hasCookies();

	public abstract List<Cookie> getCookies();

	public abstract HttpClient clearCookies();

	/** Defines the interface of a HttpClient builder. */
	public static interface Builder {
		public abstract HttpClient build();
	}
}